name: backend
version: 0.8.1
license: BSD3
copyright: Copyright (C) Obsidian Systems LLC 2018
author: Obsidian Systems LLC
maintainer: maintainer@obsidian.systems
stability: Experimental
build-type: Simple
cabal-version: >=1.8

flag support-systemd-journal
  description: Include support for systemd journal logging
    default: True

library
  hs-source-dirs: src

  build-depends:
      aeson
    , async
    , base
    , base16-bytestring
    , base58-bytestring
    , bytestring
    -- , Chart
    -- , Chart-diagrams
    , clientsession
    , colour
    , common
    , constraints
    , constraints-extras
    , containers
    , data-default
    , database-id-class
    , database-id-groundhog
    , dependent-map
    , dependent-sum
    , dependent-sum-template
    , directory
    -- , diagrams-core
    -- , diagrams-lib
    -- , diagrams-svg
    , errors
    , exceptions
    , filepath
    , formatting
    , frontend
    , functor-infix
    , generic-deriving
    , gargoyle-postgresql-connect
    , groundhog
    , groundhog-postgresql
    , groundhog-th
    , here
    , hashable
    , http-client
    , http-client-tls
    , http-conduit
    , http-types
    , io-streams
    , IntervalMap
    , lens
    , lens-aeson
    , mime-mail
    , modern-uri
    , monad-control
    , monad-logger
    , monoidal-containers
    , mtl
    , named == 0.3.*
    , network
    , obelisk-asset-serve-snap
    , obelisk-backend
    , obelisk-backend
    , obelisk-executable-config-inject
    , obelisk-frontend
    , obelisk-route
    , postgresql-simple
    , process
    , random-extras
    , random-fu
    , reflex
    , reflex-dom-core
    , resource-pool
    , rhyolite-backend
    , rhyolite-backend-db
    , rhyolite-backend-snap
    , rhyolite-common
    , safe
    , safe-exceptions
    , semigroupoids
    , shelly
    , snap-core
    , snap-loader-static
    , snap-server
    , stm
    , svg-builder
    , template-haskell
    , temporary
    , text
    , tezos-bake-monitor-lib
    , tezos-noderpc
    , these
    , time
    , transformers
    , transformers-base
    , unix
    , universe
    , unordered-containers
    , uri-encode
    , vector
    , witherable

  exposed-modules:
    Backend

  other-modules:
    Paths_backend
    Backend.Alerts
    Backend.Alerts.Common
    Backend.CachedNodeRPC
    Backend.Common
    Backend.Common.Baker
    Backend.Common.Node
    Backend.Common.Worker
    Backend.Config
    --Backend.Graphs
    Backend.Http
    Backend.IndexQueries
    Backend.Migrations
    Backend.NodeCmd
    Backend.NotifyHandler
    Backend.RequestHandler
    Backend.Schema
    Backend.Snapshot
    Backend.STM
    Backend.Supervisor
    Backend.Telegram
    Backend.Upgrade
    Backend.Version
    Backend.ViewSelectorHandler
    Backend.WebApi
    Backend.Workers.Accusation
    Backend.Workers.Baker
    Backend.Workers.Block
    Backend.Workers.Cache
    Backend.Workers.Node
    Backend.Workers.Process
    Backend.Workers.TezosClient
    System.Which

  ghc-options: -Wall -fno-warn-unused-do-bind -fwarn-tabs -funbox-strict-fields -O2 -fprof-auto-calls -fexpose-all-unfoldings
  cpp-options: -DREAL_BUILD
  if flag(support-systemd-journal) && os(linux)
    cpp-options: -DSUPPORT_SYSTEMD_JOURNAL:

executable backend
  hs-source-dirs: src-bin
  main-is: Main.hs

  build-depends:
      base
    , backend
    , obelisk-backend

  ghc-options: -threaded -Wall -fno-warn-unused-do-bind -fwarn-tabs -funbox-strict-fields -O2 -fprof-auto-calls -rtsopts -fexpose-all-unfoldings
